/**
 * Core schema meta-schema
 */
export interface IJsonSchema {
  id?: string; // uri
  $schema?: string; // uri
  $ref?: string; // uri
  title?: string;
  description?: string;
  default?: any;
  format?: string;
  multipleOf?: number;
  maximum?: number;
  exclusiveMaximum?: boolean;
  minimum?: number;
  exclusiveMinimum?: boolean;
  maxLength?: number;
  minLength?: number;
  pattern?: string; // regex
  additionalItems?: any;
  items?: any;
  maxItems?: number;
  minItems?: number;
  uniqueItems?: boolean;
  maxProperties?: number;
  minProperties?: number;
  required?: string[];
  additionalProperties?: any;
  definitions?: {
    [name:string]: IJsonSchema;
  };
  properties?: {
    [name:string]: IJsonSchema;
  };
  patternProperties?: {
    [name:string]: IJsonSchema;
  };
  dependencies?: {
    [name:string]: any;
  };
  enum?: string[];
  type?: any;
  allOf?: IJsonSchema[];
  anyOf?: IJsonSchema[];
  oneOf?: IJsonSchema[];
  not?: IJsonSchema;
}

